<html>
<head>
<title>OgreVertexIndexData.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreVertexIndexData.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreVertexIndexData_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __VertexIndexData_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __VertexIndexData_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareIndexBuffer_8h.html">OgreHardwareIndexBuffer.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="group__RenderSystem.html#ga14f5e9e50630af9964ebbbca9f88191b">00044</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;HardwareBuffer::Usage&gt;::type</a> <a class="code" href="group__RenderSystem.html#ga14f5e9e50630af9964ebbbca9f88191b" title="Define a list of usage flags.">BufferUsageList</a>;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00048"></a><a class="code" href="classOgre_1_1VertexData.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">VertexDataAlloc</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keyword">private</span>:
<a name="l00052"></a>00052         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>&amp; rhs); <span class="comment">/* do nothing, should not use */</span>
<a name="l00054"></a>00054         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>&amp; rhs); <span class="comment">/* do not use */</span>
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classOgre_1_1VertexData.html#a53b43c61112a244ebc39ad112c964d52">00056</a>         <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* <a class="code" href="classOgre_1_1VertexData.html#a53b43c61112a244ebc39ad112c964d52">mMgr</a>;
<a name="l00057"></a>00057     <span class="keyword">public</span>:
<a name="l00064"></a>00064         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>(<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr = 0);
<a name="l00073"></a>00073         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* dcl, <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* bind);
<a name="l00074"></a>00074         ~<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>();
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classOgre_1_1VertexData.html#abac9cde9c001b97cf1fea7fd05b79cf4">00079</a>         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* <a class="code" href="classOgre_1_1VertexData.html#abac9cde9c001b97cf1fea7fd05b79cf4" title="Declaration of the vertex to be used in this operation.">vertexDeclaration</a>;
<a name="l00083"></a><a class="code" href="classOgre_1_1VertexData.html#a1cf7dacb2a133d71620abd59cb3180b0">00083</a>         <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* <a class="code" href="classOgre_1_1VertexData.html#a1cf7dacb2a133d71620abd59cb3180b0" title="The vertex buffer bindings to be used.">vertexBufferBinding</a>;
<a name="l00085"></a><a class="code" href="classOgre_1_1VertexData.html#a4cad19bf7cc1610d24d62f06149f9107">00085</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1VertexData.html#a4cad19bf7cc1610d24d62f06149f9107" title="Whether this class should delete the declaration and binding.">mDeleteDclBinding</a>;
<a name="l00087"></a><a class="code" href="classOgre_1_1VertexData.html#aa3dca90128a99a8cdcd68201ad2c2f93">00087</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1VertexData.html#aa3dca90128a99a8cdcd68201ad2c2f93" title="The base vertex index to start from.">vertexStart</a>;
<a name="l00089"></a><a class="code" href="classOgre_1_1VertexData.html#a0b59b63cc2dbede1c5fc6a932fd2c10d">00089</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1VertexData.html#a0b59b63cc2dbede1c5fc6a932fd2c10d" title="The number of vertices used in this operation.">vertexCount</a>;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00093"></a><a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html">00093</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html" title="Struct used to hold hardware morph / pose vertex data information.">HardwareAnimationData</a>
<a name="l00094"></a>00094         {
<a name="l00095"></a><a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html#a0662d8e6ede8a7cdbb387db40e77c989">00095</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html#a0662d8e6ede8a7cdbb387db40e77c989">targetBufferIndex</a>;
<a name="l00096"></a><a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html#a3ebd1f099d030853fd1ac0fc2f50abb9">00096</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html#a3ebd1f099d030853fd1ac0fc2f50abb9">parametric</a>;
<a name="l00097"></a>00097         };
<a name="l00098"></a><a class="code" href="classOgre_1_1VertexData.html#a8cbc3dcd7a4375b35b8595df246756e9">00098</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;HardwareAnimationData&gt;::type</a> <a class="code" href="classOgre_1_1VertexData.html#a8cbc3dcd7a4375b35b8595df246756e9">HardwareAnimationDataList</a>;
<a name="l00100"></a><a class="code" href="classOgre_1_1VertexData.html#a43acb3f735c2d4bdfdfbfdebc26dc52e">00100</a>         <a class="code" href="classOgre_1_1VertexData.html#a8cbc3dcd7a4375b35b8595df246756e9">HardwareAnimationDataList</a> <a class="code" href="classOgre_1_1VertexData.html#a43acb3f735c2d4bdfdfbfdebc26dc52e" title="VertexElements used for hardware morph / pose animation.">hwAnimationDataList</a>;
<a name="l00102"></a><a class="code" href="classOgre_1_1VertexData.html#af24c57003d9fa3d717ca16e7f5becb41">00102</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1VertexData.html#af24c57003d9fa3d717ca16e7f5becb41" title="Number of hardware animation data items used.">hwAnimDataItemsUsed</a>;
<a name="l00103"></a>00103         
<a name="l00109"></a>00109         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* clone(<span class="keywordtype">bool</span> copyData = <span class="keyword">true</span>, <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr = 0) <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00130"></a>00130         <span class="keywordtype">void</span> prepareForShadowVolume(<span class="keywordtype">void</span>);
<a name="l00131"></a>00131 
<a name="l00145"></a><a class="code" href="classOgre_1_1VertexData.html#a154124cc2848e3eae62e9d508f45e921">00145</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1VertexData.html#a154124cc2848e3eae62e9d508f45e921" title="Additional shadow volume vertex buffer storage.">hardwareShadowVolWBuffer</a>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00166"></a>00166         <span class="keywordtype">void</span> reorganiseBuffers(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* newDeclaration, <span class="keyword">const</span> <a class="code" href="group__RenderSystem.html#ga14f5e9e50630af9964ebbbca9f88191b" title="Define a list of usage flags.">BufferUsageList</a>&amp; bufferUsage, 
<a name="l00167"></a>00167             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr = 0);
<a name="l00168"></a>00168 
<a name="l00186"></a>00186         <span class="keywordtype">void</span> reorganiseBuffers(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* newDeclaration, <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr = 0);
<a name="l00187"></a>00187 
<a name="l00197"></a>00197         <span class="keywordtype">void</span> closeGapsInBindings(<span class="keywordtype">void</span>);
<a name="l00198"></a>00198 
<a name="l00207"></a>00207         <span class="keywordtype">void</span> removeUnusedBuffers(<span class="keywordtype">void</span>);
<a name="l00208"></a>00208 
<a name="l00216"></a>00216         <span class="keywordtype">void</span> convertPackedColour(<a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> srcType, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> destType);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00234"></a>00234         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> allocateHardwareAnimationElements(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> count, <span class="keywordtype">bool</span> animateNormals);
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238     };
<a name="l00239"></a>00239 
<a name="l00241"></a><a class="code" href="classOgre_1_1IndexData.html">00241</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">IndexDataAlloc</a>
<a name="l00242"></a>00242     {
<a name="l00243"></a>00243     <span class="keyword">protected</span>:
<a name="l00245"></a>00245         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>&amp; rhs); <span class="comment">/* do nothing, should not use */</span>
<a name="l00247"></a>00247         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>&amp; rhs); <span class="comment">/* do not use */</span>
<a name="l00248"></a>00248     <span class="keyword">public</span>:
<a name="l00249"></a>00249         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>();
<a name="l00250"></a>00250         ~<a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>();
<a name="l00252"></a><a class="code" href="classOgre_1_1IndexData.html#a1a9f241fbc57ce4cce5615302da71b76">00252</a>         <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> <a class="code" href="classOgre_1_1IndexData.html#a1a9f241fbc57ce4cce5615302da71b76" title="pointer to the HardwareIndexBuffer to use, must be specified if useIndexes = true">indexBuffer</a>;
<a name="l00253"></a>00253 
<a name="l00255"></a><a class="code" href="classOgre_1_1IndexData.html#a7cd3d6f7d4af3271bfae8ce49f46ff3a">00255</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1IndexData.html#a7cd3d6f7d4af3271bfae8ce49f46ff3a" title="index in the buffer to start from for this operation">indexStart</a>;
<a name="l00256"></a>00256 
<a name="l00258"></a><a class="code" href="classOgre_1_1IndexData.html#afad8ae9cec6cab5c8c07ee5532dd89c5">00258</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1IndexData.html#afad8ae9cec6cab5c8c07ee5532dd89c5" title="The number of indexes to use from the buffer.">indexCount</a>;
<a name="l00259"></a>00259 
<a name="l00265"></a>00265         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* clone(<span class="keywordtype">bool</span> copyData = <span class="keyword">true</span>, <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr = 0) <span class="keyword">const</span>;
<a name="l00266"></a>00266 
<a name="l00275"></a>00275         <span class="keywordtype">void</span> optimiseVertexCacheTriList(<span class="keywordtype">void</span>);
<a name="l00276"></a>00276     
<a name="l00277"></a>00277     };
<a name="l00278"></a>00278 
<a name="l00284"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html">00284</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexCacheProfiler.html" title="Vertex cache profiler.">VertexCacheProfiler</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">BufferAlloc</a>
<a name="l00285"></a>00285     {
<a name="l00286"></a>00286         <span class="keyword">public</span>:
<a name="l00287"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a4b9f6e1bc8dd4f2030f5a11c6e3dfbb9">00287</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#a4b9f6e1bc8dd4f2030f5a11c6e3dfbb9">CacheType</a> {
<a name="l00288"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a4b9f6e1bc8dd4f2030f5a11c6e3dfbb9ad0fb7b7d84385dee76ad77538bb50acc">00288</a>                 FIFO, LRU
<a name="l00289"></a>00289             };
<a name="l00290"></a>00290 
<a name="l00291"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a967ec965713da4ce36c461e847f964f9">00291</a>             <a class="code" href="classOgre_1_1VertexCacheProfiler.html" title="Vertex cache profiler.">VertexCacheProfiler</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cachesize = 16, <a class="code" href="classOgre_1_1VertexCacheProfiler.html#a4b9f6e1bc8dd4f2030f5a11c6e3dfbb9">CacheType</a> cachetype = FIFO )
<a name="l00292"></a>00292                 : size ( cachesize ), type ( cachetype ), tail (0), buffersize (0), hit (0), miss (0)
<a name="l00293"></a>00293             {
<a name="l00294"></a>00294                 cache = <a class="code" href="group__Memory.html#ga3211e4a6a806aa789b38dce2432ef472" title="Allocate a block of memory for a primitive type, and indicate the category of usage.">OGRE_ALLOC_T</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>, size, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaf9e04ff475de4493bc942a9c73da4c2e" title="Geometry held in main memory.">MEMCATEGORY_GEOMETRY</a>);
<a name="l00295"></a>00295             }
<a name="l00296"></a>00296 
<a name="l00297"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a6ab7499e2083ad5f35f34a816806cef8">00297</a>             ~<a class="code" href="classOgre_1_1VertexCacheProfiler.html" title="Vertex cache profiler.">VertexCacheProfiler</a>()
<a name="l00298"></a>00298             {
<a name="l00299"></a>00299                 <a class="code" href="group__Memory.html#gacfd8dc937cf390c7bff05495f0dc10cf" title="Free the memory allocated with OGRE_MALLOC or OGRE_ALLOC_T. Category is required to be restated to en...">OGRE_FREE</a>(cache, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaf9e04ff475de4493bc942a9c73da4c2e" title="Geometry held in main memory.">MEMCATEGORY_GEOMETRY</a>);
<a name="l00300"></a>00300             }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302             <span class="keywordtype">void</span> profile(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>&amp; indexBuffer);
<a name="l00303"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a73303582f428106fc0b3177d11984228">00303</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#a73303582f428106fc0b3177d11984228">reset</a>() { hit = 0; miss = 0; tail = 0; buffersize = 0; }
<a name="l00304"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#aa8578416f0d313a75d39a30c5d47123a">00304</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#aa8578416f0d313a75d39a30c5d47123a">flush</a>() { tail = 0; buffersize = 0; }
<a name="l00305"></a>00305 
<a name="l00306"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a9f0a043c69c3b8f472cdff618bccc624">00306</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#a9f0a043c69c3b8f472cdff618bccc624">getHits</a>() { <span class="keywordflow">return</span> hit; }
<a name="l00307"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a4b6ea00ce8ef7a1d1d8676b98cd2c128">00307</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#a4b6ea00ce8ef7a1d1d8676b98cd2c128">getMisses</a>() { <span class="keywordflow">return</span> miss; }
<a name="l00308"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#ab89c85abff1af843322f4210afd25a16">00308</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#ab89c85abff1af843322f4210afd25a16">getSize</a>() { <span class="keywordflow">return</span> size; }
<a name="l00309"></a>00309         <span class="keyword">private</span>:
<a name="l00310"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#adc56faf57c63b1d1df6bb2f09892b3b5">00310</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#adc56faf57c63b1d1df6bb2f09892b3b5">size</a>;
<a name="l00311"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#ad72231fffc5f97675058ebe22bdbba27">00311</a>             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> *<a class="code" href="classOgre_1_1VertexCacheProfiler.html#ad72231fffc5f97675058ebe22bdbba27">cache</a>;
<a name="l00312"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#afb8e69a97d30c33f8ba37abe54522110">00312</a>             <a class="code" href="classOgre_1_1VertexCacheProfiler.html#a4b9f6e1bc8dd4f2030f5a11c6e3dfbb9">CacheType</a> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#afb8e69a97d30c33f8ba37abe54522110">type</a>;
<a name="l00313"></a>00313 
<a name="l00314"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a35553327f48981689555cc00eb97d339">00314</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#a35553327f48981689555cc00eb97d339">tail</a>, buffersize;
<a name="l00315"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a409b41e6232966ea68bdf0c7273eefb0">00315</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> hit, <a class="code" href="classOgre_1_1VertexCacheProfiler.html#a409b41e6232966ea68bdf0c7273eefb0">miss</a>;
<a name="l00316"></a>00316 
<a name="l00317"></a>00317             <span class="keywordtype">bool</span> inCache(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00318"></a>00318     };
<a name="l00321"></a>00321 }
<a name="l00322"></a>00322 <span class="preprocessor">#endif</span>
<a name="l00323"></a>00323 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
